#ifndef HEADER_MSGTHREAD
#define HEADER_MSGTHREAD

#include <QThread>
#include <QMutex>
#include <QtGui>
#include <boost/regex.hpp>

#include "msgClient.hh"

class MsgThread : public QThread {
	Q_OBJECT
	public:
		MsgThread(QObject *parent = 0);
		~MsgThread();
		void startListening(std::string mps, std::string mpp);
		bool testConnection();

	signals:
		void sendIni(const QString &qs);
		void sendMsg(const QString &qs);
		void planImg(const QString &qs1, const QString &qs2);
		void planRes(const QString &qs, const QColor &qc);
		void planTxt(const QString &qs);
		void sendReqP(const QString &qa, const QString &qo, const QString &qp, const QString &qv);
		void sendReq1(const QString &qo, const QString &qp, const QString &qv);
		void sendReq2(const QString &qa, const QString &qo, const QString &qp, const QString &qv);
		void sendStop();
		void planID(const QString &qs);

	public slots:
		void stopListening();
		void changeActivityNetwork(bool f);
		
	protected:
		void run();

	private:
		msgClient mp;
		std::string MP_SERVER;
		std::string MP_PORT;
		bool networkListen;
		bool initialized;
		bool m_abort;
		QMutex mutex;
};

#endif
